﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Remoting.Messaging;


namespace ETM_sample {
    class Module {
        private static ManualResetEvent _mre;
        
        public TcpClient Connect(ConnectionObject cntObj) {
            _mre = new ManualResetEvent(false);
            _mre.Reset();

            TcpClient tC = new TcpClient();

            try {
                tC.BeginConnect(cntObj.IpAdd, cntObj.Port, new AsyncCallback(ConnectCallback), tC);
                if (!_mre.WaitOne(cntObj.Timeout * 1000)) {
                    throw new SocketException(10060);
                }
            } catch (SocketException ex) {
                MessageBox.Show(ex.Message);
            } catch (AggregateException ex) {
                MessageBox.Show(ex.Message);
            }
            
            return tC;

        }

        // callback
        private void ConnectCallback(IAsyncResult ar) {
                _mre.Set();
        }
        
        public void Write(TcpObject tcpObject, string order) {
            if (tcpObject.Stm.CanWrite) {
                var sendBytes = Encoding.ASCII.GetBytes(Convert.ToString(order));
                try {
                    tcpObject.Stm.FlushAsync();
                    tcpObject.Stm.Write(sendBytes, 0, sendBytes.GetLength(0));

                } catch (Exception ex) {
                    tcpObject.Stm.Close();
                }
            } else {
            }
        }
        
        public string Read(TcpObject tcpObject) {
            string message = "";

            if (tcpObject.Stm.CanRead) {
                byte[] receivedBytes = new byte[tcpObject.Client.ReceiveBufferSize];
                tcpObject.Stm.Read(receivedBytes, 0, (int)tcpObject.Client.ReceiveBufferSize);
                message = System.Text.Encoding.UTF8.GetString(receivedBytes);

            }else {

            }
            return message;
        }
    }
}
