﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Remoting.Messaging;


namespace ETM_sample {
    public partial class Sample : Form {
        Module _etmModule;
        TcpObject _tcpObject;

        public Sample() {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e) {
            
            var etmConnection = new ConnectionObject() {
                IpAdd = IPAddress.Parse(textIpAddress.Text),
                Port = Convert.ToInt32(textPortNumber.Text),
                Timeout = Convert.ToInt32(textTimeout.Text)
            };

            _etmModule = new Module();
            _tcpObject = new TcpObject() {
                Client = _etmModule.Connect(etmConnection)
            };
            
        }

        private void buttonSend_Click(object sender, EventArgs e) {
            _etmModule = new Module();
            try {
                _tcpObject.Stm = _tcpObject.Client.GetStream();
                _etmModule.Write(_tcpObject, comboSend.Text);
            } catch (Exception ex) {
                MessageBox.Show(ex.Message);
            }

        }

        private void buttonReceive_Click(object sender, EventArgs e) {
            _etmModule = new Module();

            try {
                textReceive.Text = _etmModule.Read(_tcpObject);
            } catch(Exception ex) {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
